;
;           ZCP decoding routine v2.0 example for Ash 3.0/CrASH
;                    Wouter Demuynck (kadem@unicall.be)
;                       Read ZCP.TXT for more info
;

#include "ti82.h"                    ; include ASH aliases
#include "keys.inc"                  ; include key aliases

        .org    START_ADDR           ; (cr)ash programs start at START_ADDR
        .db     "ZCP decoder v2.0",0 ; title

Start:
        ld      HL,GRAPH_MEM      
        xor     A                 
        ld      (HL),A
        ld      DE,GRAPH_MEM + 1  
        ld      BC,$2FF           
        ldir                          ; clear GRAPH_MEM
        
        ld      DE,ZCP_Data           ; HL = address of ZCP compressed data
        ld      HL,GRAPH_MEM          ; DE = address of where uncompressed
                                      ;      data will come
        Call DecodeZCP
        ROM_CALL(DISP_GRAPH)          ; show the contents of the GRAPH_MEM

KeyLoop:
        call GET_KEY
        or a
        jr z,KeyLoop                 ; Wait for a keypress
        
        ret                          ; exit the program
        
ZCP_Data:
#include "garf.asm"                  ; include file with compressed data

#include "ZCPdecod.asm"              ; include the decoder

.end
